<?php 

// Simple 'flat file' Eventmanager for the EasyPhpEventCalendar Class
// Copyright (C) 2011 JF Nutbroek <jfnutbroek@gmail.com>

// Logindata
$login          = 'admin,password';				// Your login name, password - Change this!! (multiple comma separated)
$admin_ip       = ''; 						// Optional allow only login from this IP (multiple comma separated)

// Varify if user is coming from a valid IP address
$valid_ips = explode(',', $admin_ip);
if ($admin_ip != '' && !in_array($_SERVER['REMOTE_ADDR'], $valid_ips)) {
	header("HTTP/1.0 401 Unauthorized");
	exit;
}

session_start();

// Captcha image for login purposes
if (isset($_REQUEST['captchaimage'])) {createcaptcha();exit;}

// Check for logout
if (isset($_REQUEST['logout'])) {
	session_unset();
	session_destroy();
	require_login();
}

// Check for valid login
$captchaerror = '';
if (isset($_REQUEST['requirelogin'])) {
        if (isset($_REQUEST['captcha'])) {$captchauser = strtolower($_REQUEST['captcha']);} else {$captchauser = '';}
        if (isset($_SESSION['eventcaptchacode'])) {$captchacode = $_SESSION['eventcaptchacode'];} else {$captchacode = '';}
	$valid_users = explode(',', $login);
	if (isset($_REQUEST['new_user']) && isset($_REQUEST['new_password'])) {
                if ($captchacode == $captchauser) {
                        if (in_array($_REQUEST['new_user'], $valid_users)) {
                        	$user_index = array_search($_REQUEST['new_user'], $valid_users);
                        	if ($valid_users[$user_index + 1] != $_REQUEST['new_password']) {
                        		require_login();
                        	} else {
					$_SESSION['eventvalidlogin'] = true;
                        	}
                        } else {
                        	require_login();
                        }
                } else {
                        $captchaerror = 'Wrong code - please try again.';
                        require_login();
                }
	} else {
		require_login();
	}
} else if (isset($_SESSION['eventvalidlogin'])) {
	if ($_SESSION['eventvalidlogin'] != true)
		require_login();
} else {
	require_login();
}

// New or edited event
if (isset($_REQUEST['event_start']) && isset($_REQUEST['event'])) {
	$eventslocation = getcwd(); 
	$event_start = trim(str_replace('-', '', $_REQUEST['event_start']));
	$event_end = trim(str_replace('-', '', $_REQUEST['event_end']));
	if ($event_start != $event_end)
		$file = $event_start . $event_end . '.txt';
	else
		$file = $event_start . '.txt';
	if (isset($_REQUEST['originalevent'])) {
		if ($_REQUEST['originalevent'] != $file)
			unlink($eventslocation . '/' . basename($_REQUEST['originalevent']));
	}
	if ($fp = fopen($eventslocation . '/' . $file, 'wb')) {
		fwrite($fp, $_REQUEST['event']);
		fclose($fp);
	}
}

// Delete event
if (isset($_REQUEST['deleteevent'])) {
	$eventslocation = getcwd(); 
	unlink($eventslocation . '/' . basename($_REQUEST['deleteevent']));
}

// The page
echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\"><html xmlns=\"http://www.w3.org/1999/xhtml\">\n";
echo "<head><link rel=\"stylesheet\" type=\"text/css\" href=\"eventmanager/css.css\" /><title>Eventmanager</title>\n";
echo "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\" />\n";
echo "</head><body>\n";
echo "<form method=\"post\" action=\"eventmanager.php\" enctype=\"multipart/form-data\">\n";

// The main table
echo "<table style=\"width : 1090px;border : 0px;\" cellspacing=\"10px\" cellpadding=\"0px\"><tr><td style=\"vertical-align : top;width : 190px;\">\n";

// Options menu
topborder();
echo "<table class=\"contenttable\" style=\"width : 100%;\" cellspacing=\"0\" cellpadding=\"0\">\n";
echo "<tr><td style=\"text-align : left;font-weight : bold;\">Make a selection:</td></tr>\n";
echo "<tr><td>&nbsp;</td></tr>\n";
echo "<tr><td style=\"text-align : left;\"><a href=\"eventmanager.php?newevent=1\">Add a new event</a></td></tr>\n";
echo "<tr><td>&nbsp;</td></tr>\n";
echo "<tr><td style=\"text-align : left;\"><a href=\"eventmanager.php?listevents=1\">List all events</a></td></tr>\n";
echo "<tr><td>&nbsp;</td></tr>\n";
echo "<tr><td style=\"text-align : left;\"><a href=\"eventmanager.php?logout=1\" style=\"font-weight : bold;color : #FF0000;\">Logout</a></td></tr>\n";
echo "</table>\n";
bottomborder();

echo "</td><td style=\"vertical-align : top;width : 740px;\">";

// The content table
topborder();
echo "<table class=\"contenttable\" style=\"width : 100%;\"><tr><td style=\"vertical-align : middle;text-align : center;\">\n";

if (isset($_REQUEST['listevents'])) {

	// Content form
	echo "<table style=\"width : 100%;\">\n";
	echo "<tr><th>Edit</th><th>Event start</th><th>Event end</th><th>Delete</th></tr>\n";
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	$eventslocation = getcwd(); 
	if ($dir = opendir($eventslocation)) {
		while ($file = readdir($dir)) {
			if (strtolower(substr($file, -3)) == 'txt') {
				$event_start = $event_end = substr($file, 0, 4) . '-' . substr($file, 4, 2) . '-' . substr($file, 6, 2);
				if (strlen($file) == 20) {
					$event_end = substr($file, 8, 4) . '-' . substr($file, 12, 2) . '-' . substr($file, 14, 2);
				}
				if ($event_start == $event_end)
					$event_end = 'One day event';
				echo "<tr><td><a href=\"eventmanager.php?editevent=$file\"><img src=\"eventmanager/edit.gif\" alt=\"edit\" style=\"border : 0px;width : 14px;height : 14px;\" /></a></td><td>$event_start</td><td>$event_end</td><td><a href=\"eventmanager.php?deleteevent=$file\"><img src=\"eventmanager/delete.gif\" alt=\"del\" style=\"border : 0px;width : 14px;height : 14px;\" /></a></td></tr>\n";
			}
		}
	}
	echo "</table>\n";

} else if (isset($_REQUEST['editevent'])) {

	$file = $_REQUEST['editevent'];
	$event_start = $event_end = substr($file, 0, 4) . '-' . substr($file, 4, 2) . '-' . substr($file, 6, 2);
	if (strlen($file) == 20) {
		$event_end = substr($file, 8, 4) . '-' . substr($file, 12, 2) . '-' . substr($file, 14, 2);
	}
	$eventslocation = getcwd(); 
	if ($fp = fopen("$eventslocation/" . $file, 'r+')) {
		$text = fread($fp, filesize("$eventslocation/" . $file));
		fclose($fp);
	}
	// Content form
	echo "<table style=\"width : 100%;\">\n";
	echo "<tr><td colspan=\"2\" style=\"text-align : center;font-weight : bold;\">Edit an Event</td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"width : 250px;text-align : left;\">Start date (YYYY-MM-DD):</td><td style=\"text-align : left;\"><input type=\"text\" name=\"event_start\" class=\"input\" size=\"20\" value=\"$event_start\" /></td></tr>\n";	
	echo "<tr><td style=\"text-align : left;\">End date (YYYY-MM-DD):</td><td style=\"text-align : left;\"><input type=\"text\" name=\"event_end\" class=\"input\" size=\"20\" value=\"$event_end\" /></td></tr>\n";	
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"text-align : left;\">Event (HTML markup):</td><td style=\"text-align : left;\"><textarea class=\"input\" name=\"event\" cols=\"60\" rows=\"10\">$text</textarea></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td>&nbsp;</td><td style=\"text-align : left;\"><input type=\"hidden\" name=\"originalevent\" value=\"$file\"><input type=\"submit\" name=\"Submit\" class=\"button\" value=\"Apply changes\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "</table>\n";

} else if (isset($_REQUEST['newevent'])) {

	// Content form
	echo "<table style=\"width : 100%;\">\n";
	echo "<tr><td colspan=\"2\" style=\"text-align : center;font-weight : bold;\">Add a new Event</td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"width : 250px;text-align : left;\">Start date (YYYY-MM-DD):</td><td style=\"text-align : left;\"><input type=\"text\" name=\"event_start\" class=\"input\" size=\"20\" value=\"\" /></td></tr>\n";	
	echo "<tr><td style=\"text-align : left;\">End date (YYYY-MM-DD):</td><td style=\"text-align : left;\"><input type=\"text\" name=\"event_end\" class=\"input\" size=\"20\" value=\"\" /></td></tr>\n";	
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"text-align : left;\">Event (HTML markup):</td><td style=\"text-align : left;\"><textarea class=\"input\" name=\"event\" cols=\"60\" rows=\"10\"></textarea></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td>&nbsp;</td><td style=\"text-align : left;\"><input type=\"submit\" name=\"Submit\" class=\"button\" value=\"Add event\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "</table>\n";

} else {

	// Content form
	$event = 0;
	$eventslocation = getcwd(); 
	if ($dir = opendir($eventslocation)) {
		while ($file = readdir($dir)) {
			if (strtolower(substr($file, -3)) == 'txt') {
				$event += 1;
			}
		}
	}
	$info = '';
	if (isset($_REQUEST['deleteevent'])) {
		$info = "<span style=\"font-weight : bold;color : #FF0000;\">Event deleted!</span>";
	} else if (isset($_REQUEST['originalevent'])) {
		$info = "<span style=\"font-weight : bold;color : #FF0000;\">Event has been updated!</span>";
	} else if (isset($_REQUEST['event_start']) && isset($_REQUEST['event'])) {
		$info = "<span style=\"font-weight : bold;color : #FF0000;\">Event has been added!</span>";
	}
	echo "<p><strong>Welcome to the Eventmanager!</strong></p>$info<p>We have <strong>$event</strong> event(s) on file.</p>";
	
}

// Close the content table
echo "</td></tr></table>\n";
bottomborder();
// Footer
echo "<table style=\"width : 100%\"><tr><td><div class=\"footer\">&copy; 2011 - JF Nutbroek, EasyPhpEventCalendar and Eventmanager &lt;jfnutbroek@gmail.com&gt;</div></td></tr></table>\n";
// Close the main table
echo "</td></tr></table>\n";
// Page end
echo "</form></body></html>\n";

function topborder() {

        echo "<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n";
        echo "<td style=\"width : 39px;height : 39px;background-image : url('eventmanager/lt.gif');\">&nbsp;</td>\n";
        echo "<td style=\"background-image : url('eventmanager/tabletop.gif');\">&nbsp;</td>\n";
        echo "<td style=\"width : 39px;background-image : url('eventmanager/rt.gif');\">&nbsp;</td></tr>\n";
        echo "<tr><td style=\"background-image : url('eventmanager/tableleft.gif');\">&nbsp;</td>\n";
        echo "<td style=\"text-align : center;\">\n";           
	
}

function bottomborder() {

        echo "</td><td style=\"background-image : url('eventmanager/tableright.gif');\">&nbsp;</td></tr>\n";
        echo "<tr><td style=\"height : 39px;background-image : url('eventmanager/lb.gif');\">&nbsp;</td>\n";
        echo "<td style=\"background-image : url('eventmanager/tablebottom.gif');\">&nbsp;</td>\n";
        echo "<td style=\"background-image : url('eventmanager/rb.gif');\">&nbsp;</td>\n";
        echo "</tr></table>\n";        
	
}

function createcaptcha() {

	$chars = array('a','b','c','d','e','f','h','i','j','k','m','n','p','r','s','u','w','y','3','5','6','7','8');
	$rand_keys = array_rand($chars,5);
	$code = $chars[$rand_keys[0]] . $chars[$rand_keys[1]] . $chars[$rand_keys[2]] . $chars[$rand_keys[3]] . $chars[$rand_keys[4]];
	$_SESSION['eventcaptchacode'] = $code;
	$im = imagecreate(178,42);
	$white = imagecolorallocate($im, 255, 255, 255);
	$black = imagecolorallocate($im, 0, 0, 0);
	$grey = imagecolorallocate($im, 128, 128, 128);
	imagefilledrectangle($im, 0, 0, 178, 42, $white);	
	for ($c=0;$c<5;$c++) {
		$xpos = 10 + $c * 35;
		$fontangle = rand(-20, 20);
		imagettftext($im, 36, $fontangle, $xpos + 4, 28, $grey, 'eventmanager/font.ttf', substr($code, $c, 1));
		imagettftext($im, 36, $fontangle, $xpos, 24, $black, 'eventmanager/font.ttf', substr($code, $c, 1));
	}	
	imageline($im, 0, 10, 178, 10, $grey);
	imageline($im, 0, 20, 178, 20, $black);
	imageline($im, 0, 30, 178, 30, $grey);
	header("Content-type: image/png");
	imagepng($im);
	imagedestroy($im);
	
}

function require_login() {
	
	global $captchaerror;
	// The page
	echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\"><html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\" xml:lang=\"en\">\n";
	echo "<head><link rel=\"stylesheet\" type=\"text/css\" href=\"eventmanager/css.css\" /><title>Eventmanager</title>\n";
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\" />\n";
	echo "</head><body>\n";
	echo "<form method=\"post\" action=\"eventmanager.php?requirelogin=1\" enctype=\"multipart/form-data\"><div style=\"padding-left:50px;padding-top:50px;\">\n";
	// The main table
	echo "<table style=\"width : 400px;border : 0px;\" cellspacing=\"10px\" cellpadding=\"0px\"><tr><td style=\"vertical-align : top;\">\n";
	topborder();
	// The content table
	echo "<table class=\"contenttable\" style=\"width : 100%;\"><tr><td style=\"vertical-align : middle;text-align : center;\">\n";
	// Content	
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	echo "<tr><td style=\"width : 50%;\">&nbsp;</td><td>&nbsp;</td></tr>\n";		
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Username:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"new_user\" class=\"input\" /></td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Password:</td><td style=\"text-align : left;\"><input type=\"password\" name=\"new_password\" class=\"input\" /></td></tr>\n";
        echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Code:</td><td style=\"text-align : left;\"><img src=\"eventmanager.php?captchaimage=1\" alt=\"code\" style=\"border : 1px;border-color : #000000;border-style : solid;width : 178px;height : 42px;\" /></td></tr>\n";
        echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Repeat code:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"captcha\" class=\"input\" value=\"\" size=\"10\" maxlength=\"5\" /></td></tr>\n";   
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
        if ($captchaerror != '') {
                echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;color : #FF0000;\">$captchaerror</td></tr>\n";        
                echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";            
        }
	echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"submit\" name=\"Submit\" class=\"button\" value=\"Login\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	// Close the content table
	echo "</td></tr></table>\n";
	bottomborder();
	// Close the main table
	echo "</td></tr></table>\n";
	// Page end
	echo "</div></form></body></html>\n";
	exit;
	
}

?>
